"use strict";
var Users_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.Users = void 0;
const tslib_1 = require("tslib");
const typeorm_1 = require("typeorm");
const class_validator_1 = require("class-validator");
const class_transformer_1 = require("class-transformer");
const _1 = require(".");
const user_groups_1 = require("./user-groups");
let Users = Users_1 = class Users {
};
tslib_1.__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)(),
    tslib_1.__metadata("design:type", Number)
], Users.prototype, "id", void 0);
tslib_1.__decorate([
    (0, class_validator_1.IsNotEmpty)(),
    (0, class_validator_1.Length)(5, 100),
    (0, typeorm_1.Column)({
        type: 'varchar',
        length: 100,
        nullable: false,
        unique: true,
    }),
    tslib_1.__metadata("design:type", String)
], Users.prototype, "login", void 0);
tslib_1.__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, class_validator_1.Length)(5, 100),
    (0, typeorm_1.Column)({
        name: 'first_name',
        type: 'varchar',
        length: 100,
        nullable: true,
        default: 'NULL',
    }),
    tslib_1.__metadata("design:type", String)
], Users.prototype, "firstName", void 0);
tslib_1.__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, class_validator_1.Length)(5, 100),
    (0, class_transformer_1.Exclude)(),
    (0, typeorm_1.Column)({
        name: 'last_name',
        type: 'varchar',
        length: 100,
        nullable: true,
        default: 'NULL',
    }),
    tslib_1.__metadata("design:type", String)
], Users.prototype, "lastName", void 0);
tslib_1.__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, class_validator_1.IsBoolean)(),
    (0, typeorm_1.Column)({
        name: 'is_active',
        type: 'boolean',
        width: 1,
        nullable: true,
        default: false,
    }),
    tslib_1.__metadata("design:type", Boolean)
], Users.prototype, "isActive", void 0);
tslib_1.__decorate([
    (0, class_validator_1.IsEmpty)(),
    (0, typeorm_1.Column)({
        name: 'created_at',
        type: 'timestamp',
        nullable: true,
        default: 'CURRENT_TIMESTAMP',
    }),
    tslib_1.__metadata("design:type", Date)
], Users.prototype, "createdAt", void 0);
tslib_1.__decorate([
    (0, typeorm_1.Column)({
        name: 'test_date',
        type: 'timestamp',
        nullable: true,
        default: 'CURRENT_TIMESTAMP',
    }),
    tslib_1.__metadata("design:type", Date)
], Users.prototype, "testDate", void 0);
tslib_1.__decorate([
    (0, class_validator_1.IsEmpty)(),
    (0, typeorm_1.UpdateDateColumn)({
        name: 'updated_at',
        type: 'timestamp',
        nullable: true,
        default: 'CURRENT_TIMESTAMP',
    }),
    tslib_1.__metadata("design:type", Date)
], Users.prototype, "updatedAt", void 0);
tslib_1.__decorate([
    (0, typeorm_1.OneToOne)(() => _1.Addresses, (item) => item.id),
    (0, class_validator_1.IsNotEmpty)(),
    (0, typeorm_1.JoinColumn)({
        name: 'addresses_id',
    }),
    tslib_1.__metadata("design:type", _1.Addresses)
], Users.prototype, "addresses", void 0);
tslib_1.__decorate([
    (0, typeorm_1.OneToOne)(() => Users_1, (item) => item.id),
    (0, class_validator_1.IsOptional)(),
    (0, typeorm_1.JoinColumn)({
        name: 'manager_id',
    }),
    tslib_1.__metadata("design:type", Users)
], Users.prototype, "manager", void 0);
tslib_1.__decorate([
    (0, typeorm_1.ManyToMany)(() => _1.Roles, (item) => item.users),
    (0, typeorm_1.JoinTable)({
        name: 'users_have_roles',
        inverseJoinColumn: {
            referencedColumnName: 'id',
            name: 'role_id',
        },
        joinColumn: {
            referencedColumnName: 'id',
            name: 'user_id',
        },
    }),
    tslib_1.__metadata("design:type", Array)
], Users.prototype, "roles", void 0);
tslib_1.__decorate([
    (0, typeorm_1.OneToMany)(() => _1.Comments, (item) => item.createdBy),
    tslib_1.__metadata("design:type", Array)
], Users.prototype, "comments", void 0);
tslib_1.__decorate([
    (0, typeorm_1.ManyToOne)(() => user_groups_1.UserGroups, (userGroup) => userGroup.id),
    (0, class_validator_1.IsNotEmpty)(),
    (0, typeorm_1.JoinColumn)({ name: 'user_groups_id' }),
    tslib_1.__metadata("design:type", user_groups_1.UserGroups)
], Users.prototype, "userGroup", void 0);
Users = Users_1 = tslib_1.__decorate([
    (0, typeorm_1.Entity)('users')
], Users);
exports.Users = Users;
//# sourceMappingURL=users.js.map